/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.data.TypeId;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;

public final class Shared {
  private Shared() {}
  public static final String PC = "CIA";

  public static final Type BYTE = Type.def("BYTE", Type.CARD(8));
  public static final Type WORD = Type.def("WORD", Type.INT(32));
  public static final Type SHORT = Type.def("SHORT", Type.INT(16));
  public static final Type INDEX = Type.def("INDEX", Type.CARD(5));
  public static final Type BIT = Type.def("BIT", Type.CARD(1));
  public static final Type JUMP_IMM = Type.def("JUMP_IMM", Type.CARD(26));

  public static final Memory GPR = Memory.def(Memory.Kind.REG, "GPR", WORD, 0x20);
  public static final Memory COP0_R = Memory.def(Memory.Kind.REG, "COP0_R", WORD, 0x20);
  public static final Memory HI = Memory.def(Memory.Kind.REG, "HI", WORD, 0x1);
  public static final Memory LO = Memory.def(Memory.Kind.REG, "LO", WORD, 0x1);
  public static final Memory CIA = Memory.def(Memory.Kind.REG, "CIA", WORD, 0x1);
  public static final Memory M = Memory.def(Memory.Kind.MEM, "M", WORD, 0x40000000);
  public static final Memory BRANCH = Memory.def(Memory.Kind.REG, "BRANCH", BIT, 0x1);
  public static final Memory JMPADDR = Memory.def(Memory.Kind.REG, "JMPADDR", WORD, 0x1);
  public static final Memory is_delay_slot = Memory.def(Memory.Kind.VAR, "is_delay_slot", BIT, 0x1);
  public static final Memory jump_address = Memory.def(Memory.Kind.VAR, "jump_address", WORD, 0x1);
  public static final Memory nia = Memory.def(Memory.Kind.VAR, "nia", WORD, 0x1);
  public static final Memory temp = Memory.def(Memory.Kind.VAR, "temp", Type.INT(33), 0x1);
  public static final Memory temp_jump = Memory.def(Memory.Kind.VAR, "temp_jump", Type.CARD(28), 0x1);
  public static final Memory mult_result = Memory.def(Memory.Kind.VAR, "mult_result", Type.INT(64), 0x1);
  public static final Memory mult_result_unsigned = Memory.def(Memory.Kind.VAR, "mult_result_unsigned", Type.CARD(64), 0x1);

  public static final Memory[] __REGISTERS = {GPR, COP0_R, HI, LO, CIA, BRANCH, JMPADDR};
  public static final Memory[] __MEMORY = {M};
  public static final Memory[] __VARIABLES = {is_delay_slot, jump_address, nia, temp, temp_jump, mult_result, mult_result_unsigned};
  public static final Label[] __LABELS = {new Label("PC", CIA, 0)};
}
 