/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class mflo extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mflo.class,
         "mflo",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, REG.INFO),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);

      return new mflo(rd);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mflo",
          true,
          new ArgumentDecls()
              .add("rd", ArgumentMode.OUT, REG.INFO),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);

      return new instruction(
        new mflo(
          rd
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG rd;

  public mflo(final REG rd) {
    assert REG.INFO.isSupported(rd);
    this.rd = rd;
  }

  @Override
  public String syntax() {
    return String.format("mflo %s", rd.syntax());
  }

  @Override
  public String image() {
    return String.format("0000000000000000%s00000010010", rd.image());
  }

  @Override
  public void action() {
    rd.access().store(LO.access(0).load());
  }
}
