/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.Shared.*;

public final class MFF extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MFF.class,
         "MFF",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.OUT, R.INFO)
             .add("fs", ArgumentMode.IN, F.INFO),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final F fs = (F) getArgument("fs", args);

      return new MFF(rt, fs);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rt;
  public final F fs;

  public MFF(final R rt, final F fs) {
    assert R.INFO.isSupported(rt);
    assert F.INFO.isSupported(fs);
    this.rt = rt;
    this.fs = fs;
  }

  @Override
  public String syntax() {
    return String.format("MFF %s, %s", rt.syntax(), fs.syntax());
  }

  @Override
  public String image() {
    return String.format("01000100000%s%s00000000000", rt.image(), fs.image());
  }

  @Override
  public void action() {
    rt.access().store(fs.access().load());
  }
}
