/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.Shared.*;

public final class MOVT_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOVT_S.class,
         "MOVT_S",
         false,
         new ArgumentDecls()
             .add("fd", ArgumentMode.OUT, F.INFO)
             .add("fs", ArgumentMode.IN, F.INFO)
             .add("cc", COND_CODE),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final F fd = (F) getArgument("fd", args);
      final F fs = (F) getArgument("fs", args);
      final Immediate cc = (Immediate) getArgument("cc", args);

      return new MOVT_S(fd, fs, cc);
    }
  }

  public static final IInfo INFO = new Info();

  public final F fd;
  public final F fs;
  public final Immediate cc;

  public MOVT_S(final F fd, final F fs, final Immediate cc) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert COND_CODE.equals(cc.getType());
    this.fd = fd;
    this.fs = fs;
    this.cc = cc;
  }

  @Override
  public String syntax() {
    return String.format("MOVT_S %s, %s", fd.syntax(), fs.syntax());
  }

  @Override
  public String image() {
    return String.format("01000110000%s01%s%s010001", cc.access().load().toString(), fs.image(), fd.image());
  }

  @Override
  public void action() {
    if (FCCR.access().bitField(cc.access().load(), cc.access().load()).load().equals(Data.valueOf(Type.INT(1), 0x1))) {
      fd.access().store(fs.access().load());
    }
  }
}
