/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.Shared.*;

public final class SLL extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SLL.class,
         "SLL",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, R.INFO)
             .add("rt", ArgumentMode.IN, R.INFO)
             .add("sa", INDEX),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate sa = (Immediate) getArgument("sa", args);

      return new SLL(rd, rt, sa);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rd;
  public final R rt;
  public final Immediate sa;

  public SLL(final R rd, final R rt, final Immediate sa) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rt);
    assert INDEX.equals(sa.getType());
    this.rd = rd;
    this.rt = rt;
    this.sa = sa;
  }

  @Override
  public String syntax() {
    return String.format("SLL %s, %s, %d", rd.syntax(), rt.syntax(), sa.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("00000000000%s%s%s000000", rt.image(), rd.image(), sa.access().load().toString());
  }

  @Override
  public void action() {
    rd.access().store(rt.access().load().shiftLeft(sa.access().load()));
  }
}
